/********************************************
 * UTIA AV CR, v.v.i
 * Signal Processing Department
 * Pod Vodarenskou vezi 4
 * 182 08 Prague
 * Czech Republic
 * web: http://zs.utia.cas.cz
 * contact: sp@utia.cz
 *
 * Filename: i2c_im.h
 * Date: 2022.03.03
 * Author: Lukas Kohout <kohoutl@utia.cas.cz>
 * Description:
 *    I2C controller init
 *
 * Changelog:
 *
 *
 *
 *
 ********************************************/


#ifndef _I2C_IM_HEADER_FILE_
#define _I2C_IM_HEADER_FILE_

#ifdef __cplusplus
extern "C" {
#endif


#define IM_I2C_SLAVE_FORCE    0x0706
#define IM_I2C_SLAVE          0x0703  /* Change slave address */
#define IM_I2C_FUNCS          0x0705  /* Get the adapter functionality */
#define IM_I2C_RDWR           0x0707  /* Combined R/W transfer (one stop only) */



#define IM_RSTN               0x01

#define IM_MUX_ADDR           0x70  // 0xE0/0xE1 (PCA9546A)
#define IM_MUX_EDID_DATA      0x01  //
#define IM_MUX_ADV7511_DATA   0x02  // ADV7511
#define IM_MUX_ADV7611_DATA   0x04  // ADV7611
#define IM_MUX_IO_EXP_DATA    0x08  // PCA9555 IO Expander
#define IM_MUX_CAM_DATA       0x10  //

#define IM_I2C_IO_EXP_ADDR    0x20  // 0x40/0x41


typedef struct {
    unsigned int  gpio_base;
    unsigned char pin;
} im_reset_t;


int i2c_im_write(int i2c_fd, unsigned char dev_addr, unsigned char reg, unsigned char data);
int i2c_im_read(int i2c_fd, unsigned char dev_addr, unsigned char reg);
int i2c_im_sel(int i2c_fd, unsigned char sel);
int i2c_im_init(char *i2c_device, im_reset_t *rst);
void i2c_im_deinit(int *i2c_fd);


#ifdef __cplusplus
}
#endif

#endif
