
#ifndef HBLANK_DET_H
#define HBLANK_DET_H


/****************** Include Files ********************/
#ifndef __linux__
# include "xil_types.h"
# include "xstatus.h"
# include "xil_io.h"
#else
# include <stdint.h>
# include <stdio.h>
# include <stdlib.h>
#endif

#define HBLANK_DET_S00_AXI_SLV_REG0_OFFSET 0
// #define HBLANK_DET_S00_AXI_SLV_REG1_OFFSET 4
// #define HBLANK_DET_S00_AXI_SLV_REG2_OFFSET 8
// #define HBLANK_DET_S00_AXI_SLV_REG3_OFFSET 12


#ifdef __linux__
typedef uint8_t u8;
typedef uint16_t u16;
typedef uint32_t u32;
#endif


/**************************** Type Definitions *****************************/
/**
 *
 * Write a value to a HBLANK_DET register. A 32 bit write is performed.
 * If the component is implemented in a smaller width, only the least
 * significant data is written.
 *
 * @param   BaseAddress is the base address of the HBLANK_DETdevice.
 * @param   RegOffset is the register offset from the base to write to.
 * @param   Data is the data written to the register.
 *
 * @return  None.
 *
 * @note
 * C-style signature:
 * 	void HBLANK_DET_mWriteReg(u32 BaseAddress, unsigned RegOffset, u32 Data)
 *
 */
#ifndef __linux__
#define HBLANK_DET_mWriteReg(BaseAddress, RegOffset, Data) \
  	Xil_Out32((BaseAddress) + (RegOffset), (u32)(Data))
#else
#define HBLANK_DET_mWriteReg(BaseAddress, RegOffset, Data) \
    *(volatile u32*)((BaseAddress) + (RegOffset)) = (u32)(Data)
#endif

/**
 *
 * Read a value from a HBLANK_DET register. A 32 bit read is performed.
 * If the component is implemented in a smaller width, only the least
 * significant data is read from the register. The most significant data
 * will be read as 0.
 *
 * @param   BaseAddress is the base address of the HBLANK_DET device.
 * @param   RegOffset is the register offset from the base to write to.
 *
 * @return  Data is the data from the register.
 *
 * @note
 * C-style signature:
 * 	u32 HBLANK_DET_mReadReg(u32 BaseAddress, unsigned RegOffset)
 *
 */
#ifndef __linux__
#define HBLANK_DET_mReadReg(BaseAddress, RegOffset) \
    Xil_In32((BaseAddress) + (RegOffset))
#else
#define HBLANK_DET_mReadReg(BaseAddress, RegOffset) \
    *(volatile u32*)((BaseAddress) + (RegOffset))
#endif

/************************** Function Prototypes ****************************/
/**
 *
 * Run a self-test on the driver/device. Note this may be a destructive test if
 * resets of the device are performed.
 *
 * If the hardware system is not built correctly, this function may never
 * return to the caller.
 *
 * @param   baseaddr_p is the base address of the HBLANK_DET instance to be worked on.
 *
 * @return
 *
 *    - XST_SUCCESS   if all self-test code passed
 *    - XST_FAILURE   if any self-test code failed
 *
 * @note    Caching must be turned off for this function to work.
 * @note    Self test may fail if data memory and device are not on the same bus.
 *
 */

#endif // HBLANK_DET_H
